/*
tabs  1  4  8 12 16 20 24 28 32 36 40 44 48 52 56 60 64 68 72 76 80 84 88 92 96
*/

/************************************************************************\
 *                                                                      *
 *  Mod2Gen v0.5                                                        *
 *                                                                      *
 *  Convertit la liste des fichiers de MODULA en liste de type          *
 *  'Generic' pour pouvoir la convertir avec Lst2IDZ, pour Zylview.     *
 *                                                                      *
 *  v0.5 - 1er septembre 1995 par Vincent Mallet.                       *
 *                                                                      *
\************************************************************************/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

void usage(void)
{
   printf("usage: MOD2GEN  <filein> <fileout>\n\n");
   printf("   ex: Mod2gen modfic.lst modfic.gen\n\n");
   exit(1);
}

char *nicename(char *s)
{
   char *p = s;
   int lastwascut = 1;

   while (*p)
   {
       if (lastwascut)
           *p = toupper(*p);
       else
           *p = tolower(*p);

       lastwascut = (int) strchr("- _/.;:,*+", *p);
       p++;
   }

   return s;
}

int main(int argc, char **argv)
{
   FILE *fin, *fout;
   char buf[200], *p, *q;
   int area = 0;

   printf("Mod2Gen v0.5 - Convertit la liste de MODULA en format 'Generic' - vmallet 1995\n\n");

   if (argc != 3)
       usage();

   fin = fopen(*++argv, "rt");
   if (NULL == fin)
   {
       printf("Impossible d'ouvrir: %s\n", *argv);
       exit(1);
   }
   if (setvbuf(fin, NULL, _IOFBF, 25000))
   {
       printf("setvbuf() error pour fin\n");
       exit(1);
   }

   fout = fopen(*++argv, "wt");
   if (NULL == fout)
   {
       printf("Impossible d'ouvrir: %s\n", *argv);
       exit(1);
   }
   if (setvbuf(fout, NULL, _IOFBF, 25000))
   {
       printf("setvbuf() error pour fout\n");
       exit(1);
   }

   printf("Converting...\n");
   while (fgets(buf, 150, fin))
   {
       if (*buf != '\%')
       {
           if (*buf != ' ')
               fputs(buf, fout);
           else
           {
               p = buf;
               while (*p == ' ')
                   p++;

               if (p-buf > 35)
                   fputs(buf, fout);
               else
               {
                   switch((unsigned char)*p)
                   {
                       case 0xDA:
                       case 0xC0:  break;
                       case 0xB3:
                           q = strstr(p, "REPERTOIRE");
                           if (q)
                           {
                               q += 13;
                               p = strrchr(q, '');
                               if (p)
                               {
                                   p--;
                                   while (*p == ' ')
                                       p--;
                                   *++p = '\0';
                               }
                               area++;
                               printf("\rArea_Start %d: %s", area, nicename(q));
                               fprintf(fout, "\nArea_Start %d: %s\n", area, q);
                           }
                           break;
                       default:    fputs(buf, fout); break;
                   }
               }
           }
       }
   }


   printf("\n%d areas converted.\n", area);
   printf("Done.\n");

   fclose(fin);
   fclose(fout);

   return 0;
}
